@function conditional-offset($value, $offsets) {
  $r: null;

  @if ($offsets != null) {
    $offsets: list-up-depth-to($offsets, 2);

    @each $op, $bound, $offset in $offsets {
      @if eval-comparision($value, $bound, $op) {
        $r: if-is-null($r, '', $r + ' + ') + '#{$offset}';
      }
    }
  }

  @return $r;
}

@function media-min-max-join($config, $offset: null, $cond-offsets: null) {
  $config: list-up-depth-to($config, 2);

  $condition: null;
  @each $max, $min in $config {
    $condition: if-is-null($condition, '', $condition + ', ');

    @each $type, $value,
      $prefix in ('max' $max '', 'min' $min if-is-null($max, '', ' and '))
    {
      @if $value != null {
        $o: $offset;
        $cnd-off: conditional-offset($value, $cond-offsets);
        @if ($cnd-off != null) {
          $o: if-is-null($o, $cnd-off, '#{$o} + #{$cnd-off}');
        }

        @if (unitless($value)) {
          $value: '#{$value}px';
        }

        @if $o != null {
          $value: 'calc(#{$value} + #{$o})';
        }

        $condition: $condition + '#{$prefix}(#{$type}-width: #{$value})';
      }
    }
  }

  @return $condition;
}
